%global debug_package %{nil}

Name: rustscan
Version: 2.4.1
Release: 1%{?dist}
Summary: Faster Nmap Scanning with Rust

License: GPL-3.0-or-later
URL: https://github.com/RustScan/RustScan
Source0: %{url}/archive/%{version}/%{name}-%{version}.tar.gz

%if 0%{?el8} || 0%{?el9}
%else
BuildRequires: cargo >= 1.59
BuildRequires: rust >= 1.59
%endif
BuildRequires: gcc

%if 0%{?fedora} || 0%{?rhel} >= 8
Recommends: nmap%{?_isa}
%endif

%description
What is this?

- Find ports quickly using Rustscan (3 seconds at its fastest).
- Automatically runs nmap on those ports.
- ???
- Profit!

RustScans only job is to reduce the friction between finding open ports and
inputting them into nmap.

Features:

- Scans all 65k ports in 8 seconds (on 10k batch size).
- Saves you time by automatically piping it into Nmap. No more manual copying
  and pasting!
- Does one thing and does it well. Only purpose is to improve Nmap, not
  replace it!
- Let's you choose what Nmap commands to run, or uses the default.
- IPv6 Support


%prep
%autosetup -n RustScan-%{version} -p1
%if 0%{?el8} || 0%{?el9}
  curl https://sh.rustup.rs -sSf | sh -s -- --profile minimal -y
%endif

# Set codegen-units to 1
# echo 'codegen-units = 1' >> Cargo.toml


%install
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=3
%if 0%{?el8} || 0%{?el9}
. "$HOME/.cargo/env"
%endif
cargo install --root=%{buildroot}%{_prefix} --path=.

rm -f %{buildroot}%{_prefix}/.crates.toml \
    %{buildroot}%{_prefix}/.crates2.json
strip --strip-all %{buildroot}%{_bindir}/*


%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}


%changelog
* Sun Feb 23 2025 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.1-1
- chore: Update to latest release

* Wed May 01 2024 Artem Polishchuk <ego.cordatus@gmail.com> - 2.2.3-1
- chore: Update to latest release

* Sun Apr 21 2024 Artem Polishchuk <ego.cordatus@gmail.com> - 2.2.2-1
- chore: Update to latest release

* Wed Nov 09 2022 Artem Polishchuk <ego.cordatus@gmail.com> - 2.1.1-1
- chore(update): 2.1.1

* Wed Apr 27 2022 Artem Polishchuk <ego.cordatus@gmail.com> - 2.1.0-1
- chore(update): 2.1.0

* Fri Nov  6 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.0.1-1
- build(update): 2.0.1

* Fri Nov  6 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.0.0-1
- build(update): 2.0.0

* Tue Sep 29 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 1.10.1-1
- Update to 1.10.1

* Tue Sep 29 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 1.10.0-1
- Update to 1.10.0

* Sun Sep 20 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 1.9.0-1
- Update to 1.9.0

* Fri Aug 28 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 1.8.0-2
- Add 'nmap' as weak dep

* Fri Aug 28 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 1.8.0-1
- Initial package
